All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends
faiss::gpu::GpuIndex Class Referenceabstract
Inheritance diagram for faiss::gpu::GpuIndex:

## Public Member Functions

| GpuIndex (GpuResources *resources, int device, int dims, faiss::MetricType metric)
int | getDevice () const
GpuResources * | getResources ()
virtual void | add (faiss::Index::idx_t, const float *x)
virtual void | add_with_ids (Index::idx_t n, const float *x, const Index::idx_t *ids)
virtual void | search (faiss::Index::idx_t n, const float *x, faiss::Index::idx_t k, float *distances, faiss::Index::idx_t *labels) const
Public Member Functions inherited from faiss::Index
| Index (idx_t d=0, MetricType metric=METRIC_INNER_PRODUCT)
virtual void | train (idx_t n, const float *x)
virtual void | range_search (idx_t n, const float *x, float radius, RangeSearchResult *result) const
void | assign (idx_t n, const float *x, idx_t *labels, idx_t k=1)
virtual void | reset ()=0
| removes all elements from the database.
virtual long | remove_ids (const IDSelector &sel)
virtual void | reconstruct (idx_t key, float *recons) const
virtual void | reconstruct_n (idx_t i0, idx_t ni, float *recons) const
void | compute_residual (const float *x, float *residual, idx_t key) const
void | display () const
virtual std::string | get_typename () const
virtual void | set_typename ()=0

## Protected Member Functions

void | addInternal_ (Index::idx_t n, const float *x, const Index::idx_t *ids)
virtual void | addImpl_ (Index::idx_t n, const float *x, const Index::idx_t *ids)=0
| Overridden to actually perform the add.
virtual void | searchImpl_ (faiss::Index::idx_t n, const float *x, faiss::Index::idx_t k, float *distances, faiss::Index::idx_t *labels) const =0
| Overridden to actually perform the search.

## Protected Attributes

GpuResources * | resources_
| Manages streans, cuBLAS handles and scratch memory for devices.
int | device_
| The GPU device we are resident on.

## Additional Inherited Members

Public Types inherited from faiss::Index
typedef long | idx_t
| all indices are this type
Public Attributes inherited from faiss::Index
std::string | index_typename
int | d
| vector dimension
idx_t | ntotal
| total nb of indexed vectors
bool | verbose
| verbosity level
bool | is_trained
| set if the Index does not require training, or if training is done already
MetricType | metric_type
| type of metric this index uses for search

## Detailed Description

Definition at line 20 of file GpuIndex.h.

## Member Function Documentation

void faiss::gpu::GpuIndex::add | ( | faiss::Index::idx_t | n,
|  | const float * | x
| ) |  |

virtual

`x` can be resident on the CPU or any GPU; copies are performed as needed Handles paged adds if the add set is too large; calls addInternal_

Implements faiss::Index.

Reimplemented in faiss::gpu::GpuIndexIVF.

Definition at line 37 of file GpuIndex.cu.

void faiss::gpu::GpuIndex::add_with_ids | ( | Index::idx_t | n,
|  | const float * | x,
|  | const Index::idx_t * | ids
| ) |  |

virtual

`x` and `ids` can be resident on the CPU or any GPU; copies are performed as needed Handles paged adds if the add set is too large; calls addInternal_

Reimplemented from faiss::Index.

Definition at line 42 of file GpuIndex.cu.

void faiss::gpu::GpuIndex::addInternal_ | ( | Index::idx_t | n,
|  | const float * | x,
|  | const Index::idx_t * | ids
| ) |  |

protected

Handles paged adds if the add set is too large, passes to addImpl_ to actually perform the add for the current page

Definition at line 49 of file GpuIndex.cu.

void faiss::gpu::GpuIndex::search | ( | faiss::Index::idx_t | n,
|  | const float * | x,
|  | faiss::Index::idx_t | k,
|  | float * | distances,
|  | faiss::Index::idx_t * | labels
| ) |  | const

virtual

`x`, `distances` and `labels` can be resident on the CPU or any GPU; copies are performed as needed

Implements faiss::Index.

Reimplemented in faiss::gpu::GpuIndexFlat.

Definition at line 80 of file GpuIndex.cu.

The documentation for this class was generated from the following files:

- /data/users/matthijs/github_faiss/faiss/gpu/GpuIndex.h
- /data/users/matthijs/github_faiss/faiss/gpu/GpuIndex.cu